"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function genActiveRule(routerPrefix) {
  return function (location) {
    return location.pathname.startsWith(routerPrefix);
  };
}

var _default = {
  dev: [{
    name: 'web4_console',
    entry: "//".concat(window.location.hostname, ":3020/civweb4"),
    container: '#micro-container',
    activeRule: genActiveRule('/civbase/civweb4'),
    props: {}
  }, {
    name: 'civweb5',
    entry: "//".concat(window.location.hostname, ":3008/civbase/civweb5"),
    container: '#micro-container',
    activeRule: genActiveRule('/civbase/civweb5')
  }],
  prod: [{
    name: 'web4_console',
    entry: "//".concat(window.location.host, "/civweb4"),
    container: '#micro-container',
    activeRule: genActiveRule('/civbase/civweb4'),
    props: {}
  }, {
    name: 'civweb5',
    entry: "//".concat(window.location.host, "/civweb5"),
    container: '#micro-container',
    activeRule: genActiveRule('/civbase/civweb5')
  }]
};
exports["default"] = _default;