import React from 'react';

import {
  Helmet,
  HelmetProvider,
} from 'react-helmet-async';
import { connect } from 'react-redux';
import { renderRoutes } from 'react-router-config';

import {
  getMenuData,
  getPageTitle,
} from '@ant-design/pro-layout';

// import logo from '../assets/logo.svg';
import styles from './UserLayout.less';

const UserLayout = props => {
  const {
    route = {
      routes: [],
    },
  } = props;
  // const { formatMessage } = useIntl();
  console.log("route.routes", route.routes)
  const { breadcrumb } = getMenuData(route.routes);
  const title = getPageTitle({
    // pathname: location.pathname,
    // formatMessage,
    breadcrumb,
    title: props.global && props.global.title || "",
    ...props,
  });

  return (
    <HelmetProvider>
      <Helmet>
        <title>{title}</title>
        <link rel="shortcut icon" href={`https://panda-water.cn/web4/${props.global && props.global.shortcutIcon}`}/>
        <meta name="description" content={title} />
      </Helmet>

      <div className={styles.container}>
        <div className={styles.content}>
          {/* <div className={styles.top}>
            <div className={styles.header}>
                <img alt="logo" className={styles.logo} src={`https://panda-water.cn/web4/${props.global.logo}`} />
                <span className={styles.title}>{props.global.title}</span>
            </div>
            <div className={styles.desc}>{props.global.subtitle}</div>
          </div> */}
          {renderRoutes(route.routes)}
        </div>
        {/* <DefaultFooter links={[]} copyright="Copyright © 熊猫智慧水务 2020 All Rights Reserved 沪ICP备11036640-1"/> */}
      </div>
    </HelmetProvider>
  );
};
const mapStateToProps = (state) => {
  return {
    global: state.getIn(['global', 'globalConfig'])
  }
}
export default connect(mapStateToProps, null)(UserLayout);
